function ResizeLayer(W, H) {
  var idTrnf = charIDToTypeID( "Trnf" );
      var desc154 = new ActionDescriptor();
      var idnull = charIDToTypeID( "null" );
          var ref135 = new ActionReference();
          var idLyr = charIDToTypeID( "Lyr " );
          var idOrdn = charIDToTypeID( "Ordn" );
          var idTrgt = charIDToTypeID( "Trgt" );
          ref135.putEnumerated( idLyr, idOrdn, idTrgt );
      desc154.putReference( idnull, ref135 );
      var idFTcs = charIDToTypeID( "FTcs" );
      var idQCSt = charIDToTypeID( "QCSt" );
      var idQcsa = charIDToTypeID( "Qcsa" );
      desc154.putEnumerated( idFTcs, idQCSt, idQcsa );
      var idOfst = charIDToTypeID( "Ofst" );
          var desc155 = new ActionDescriptor();
          var idHrzn = charIDToTypeID( "Hrzn" );
          var idPxl = charIDToTypeID( "#Pxl" );
          desc155.putUnitDouble( idHrzn, idPxl, 0.000000 );
          var idVrtc = charIDToTypeID( "Vrtc" );
          var idPxl = charIDToTypeID( "#Pxl" );
          desc155.putUnitDouble( idVrtc, idPxl, 0.000000 );
      var idOfst = charIDToTypeID( "Ofst" );
      desc154.putObject( idOfst, idOfst, desc155 );
      var idWdth = charIDToTypeID( "Wdth" );
      var idPrc = charIDToTypeID( "#Prc" );
      desc154.putUnitDouble( idWdth, idPrc, W);
      var idHght = charIDToTypeID( "Hght" );
      var idPrc = charIDToTypeID( "#Prc" );
      desc154.putUnitDouble( idHght, idPrc, H);
      var idLnkd = charIDToTypeID( "Lnkd" );
      desc154.putBoolean( idLnkd, true );
  executeAction( idTrnf, desc154, DialogModes.NO );
    }
    
function ContentAwareResizeLayer(W, H) {
  var idTrnf = charIDToTypeID( "Trnf" );
      var desc2 = new ActionDescriptor();
      var idnull = charIDToTypeID( "null" );
          var ref1 = new ActionReference();
          var idLyr = charIDToTypeID( "Lyr " );
          var idOrdn = charIDToTypeID( "Ordn" );
          var idTrgt = charIDToTypeID( "Trgt" );
          ref1.putEnumerated( idLyr, idOrdn, idTrgt );
      desc2.putReference( idnull, ref1 );
      var idFTcs = charIDToTypeID( "FTcs" );
      var idQCSt = charIDToTypeID( "QCSt" );
      var idQcsa = charIDToTypeID( "Qcsa" );
      desc2.putEnumerated( idFTcs, idQCSt, idQcsa );
      var idOfst = charIDToTypeID( "Ofst" );
          var desc3 = new ActionDescriptor();
          var idHrzn = charIDToTypeID( "Hrzn" );
          var idPxl = charIDToTypeID( "#Pxl" );
          desc3.putUnitDouble( idHrzn, idPxl, 0.000000 );
          var idVrtc = charIDToTypeID( "Vrtc" );
          var idPxl = charIDToTypeID( "#Pxl" );
          desc3.putUnitDouble( idVrtc, idPxl, 0.000000 );
      var idOfst = charIDToTypeID( "Ofst" );
      desc2.putObject( idOfst, idOfst, desc3 );
      var idWdth = charIDToTypeID( "Wdth" );
      var idPrc = charIDToTypeID( "#Prc" );
      desc2.putUnitDouble( idWdth, idPrc, W);
      var idHght = charIDToTypeID( "Hght" );
      var idPrc = charIDToTypeID( "#Prc" );
      desc2.putUnitDouble( idHght, idPrc, H);
      var idLnkd = charIDToTypeID( "Lnkd" );
      desc2.putBoolean( idLnkd, true );
      var idcontentAware = stringIDToTypeID( "contentAware" );
      desc2.putBoolean( idcontentAware, true );
      
      var idskinTone = stringIDToTypeID( "skinTone" );
      desc2.putBoolean( idskinTone, dlg.ProtectSkin.value );
      
      var idAmnt = charIDToTypeID( "Amnt" );
      desc2.putDouble( idAmnt, 100.000000 );
  executeAction( idTrnf, desc2, DialogModes.NO );
  }

//Make sure there's more than 1 layer
var NumberOfLayers = app.activeDocument.layers.length;
if (NumberOfLayers < 2) alert("Not enough layers!");
else {

//SELECT BOTTOM LAYER
app.activeDocument.activeLayer = app.activeDocument.layers[NumberOfLayers-1];

var ADegreeH = 100;
var ADegreeW = 100;
var BDegreeH = 100;
var BDegreeW = 100;

var dlg = new Window('dialog', 'Animated Content Aware Scale' );
dlg.frameLocation = [200, 300];

dlg.orientation = 'column';

dlg.H1Panel = dlg.add("panel",undefined,"Starting Height");
dlg.H1Panel.alignChildren = "right";
dlg.H1Panel.orientation = 'row';
dlg.H1Panel.sliderH1 = dlg.H1Panel.add('scrollbar', undefined, 100, 1, 300);
dlg.H1Panel.sliderH1.preferH1Size = [100,20];
dlg.H1Panel.H1Value = dlg.H1Panel.add('statictext');
dlg.H1Panel.H1Value.preferH1Size = [40,25];
dlg.H1Panel.H1Value.text = Math.round(dlg.H1Panel.sliderH1.value);
dlg.H1Panel.sliderH1.onChanging = function () {
 dlg.H1Panel.H1Value.text = Math.round(dlg.H1Panel.sliderH1.value);
 ADegreeH = Math.round(dlg.H1Panel.H1Value.text);
 ADegreeW = Math.round(dlg.W1Panel.W1Value.text);
 BDegreeH = Math.round(dlg.H2Panel.H2Value.text);
 BDegreeW = Math.round(dlg.W2Panel.W2Value.text);
};


dlg.W1Panel = dlg.add("panel",undefined,"Starting Width");
dlg.W1Panel.alignChildren = "right";
dlg.W1Panel.orientation = 'row';
dlg.W1Panel.sliderW1 = dlg.W1Panel.add('scrollbar', undefined, 100, 1, 300);
dlg.W1Panel.sliderW1.preferW1Size = [100,20];
dlg.W1Panel.W1Value = dlg.W1Panel.add('statictext');
dlg.W1Panel.W1Value.preferW1Size = [40,25];
dlg.W1Panel.W1Value.text = Math.round(dlg.W1Panel.sliderW1.value);
dlg.W1Panel.sliderW1.onChanging = function () {
 dlg.W1Panel.W1Value.text = Math.round(dlg.W1Panel.sliderW1.value);
 ADegreeH = Math.round(dlg.H1Panel.H1Value.text);
 ADegreeW = Math.round(dlg.W1Panel.W1Value.text);
 BDegreeH = Math.round(dlg.H2Panel.H2Value.text);
 BDegreeW = Math.round(dlg.W2Panel.W2Value.text);
};

dlg.H2Panel = dlg.add("panel",undefined,"Ending Height");
dlg.H2Panel.alignChildren = "right";
dlg.H2Panel.orientation = 'row';
dlg.H2Panel.sliderH2 = dlg.H2Panel.add('scrollbar', undefined, 100, 1, 300);
dlg.H2Panel.sliderH2.preferH2Size = [100,20];
dlg.H2Panel.H2Value = dlg.H2Panel.add('statictext');
dlg.H2Panel.H2Value.preferH2Size = [40,25];
dlg.H2Panel.H2Value.text = Math.round(dlg.H2Panel.sliderH2.value);
dlg.H2Panel.sliderH2.onChanging = function () {
 dlg.H2Panel.H2Value.text = Math.round(dlg.H2Panel.sliderH2.value);
 ADegreeH = Math.round(dlg.H1Panel.H1Value.text);
 ADegreeW = Math.round(dlg.W1Panel.W1Value.text);
 BDegreeH = Math.round(dlg.H2Panel.H2Value.text);
 BDegreeW = Math.round(dlg.W2Panel.W2Value.text);
};

dlg.W2Panel = dlg.add("panel",undefined,"Ending Width");
dlg.W2Panel.alignChildren = "right";
dlg.W2Panel.orientation = 'row';
dlg.W2Panel.sliderW2 = dlg.W2Panel.add('scrollbar', undefined, 100, 1, 300);
dlg.W2Panel.sliderW2.preferW2Size = [100,20];
dlg.W2Panel.W2Value = dlg.W2Panel.add('statictext');
dlg.W2Panel.W2Value.preferW2Size = [40,25];
dlg.W2Panel.W2Value.text = Math.round(dlg.W2Panel.sliderW2.value);
dlg.W2Panel.sliderW2.onChanging = function () {
 dlg.W2Panel.W2Value.text = Math.round(dlg.W2Panel.sliderW2.value);
 ADegreeH = Math.round(dlg.H1Panel.H1Value.text);
 ADegreeW = Math.round(dlg.W1Panel.W1Value.text);
 BDegreeH = Math.round(dlg.H2Panel.H2Value.text);
 BDegreeW = Math.round(dlg.W2Panel.W2Value.text);
};

dlg.AlgPanel = dlg.add("panel",undefined,"Algorithm");
dlg.AlgPanel.alignChildren = "left";
dlg.AlgPanel.orientation = 'column';
dlg.AlgPanel.CWR = dlg.AlgPanel.add('radiobutton', undefined, 'C.A. Scale -> Scale');
dlg.AlgPanel.RCW = dlg.AlgPanel.add('radiobutton', undefined, 'Scale -> C.A. Scale');
dlg.AlgPanel.CWCW = dlg.AlgPanel.add('radiobutton', undefined, 'C.A. Scale -> C.A. Scale');
dlg.AlgPanel.CWR.value = true;
dlg.AlgPanel.RCW.value = false;
dlg.AlgPanel.CWCW.value = false;

dlg.ProtectSkin = dlg.add('checkbox', undefined, 'Protect skin tones');
dlg.ProtectSkin.value = false;

var uiButtonRun = "Run";
dlg.btnRun = dlg.add("button", undefined ,uiButtonRun );
dlg.btnRun.onClick = function() { this.parent.close(0); };

dlg.show();

var win = new Window("window{text:'Total Progress',bounds:[100,100,400,150],bar:Progressbar{bounds:[20,20,280,31] , value:0,maxvalue:100}};");
win.show();

  var N = 1;
  var differenceH = ADegreeH - BDegreeH;
  var differenceW = ADegreeW - BDegreeW;

  while (N <= NumberOfLayers) { 

    win.bar.value = (N/NumberOfLayers) * 100;

    // TURN ON SELECTED LAYER
    app.activeDocument.activeLayer.visible = true;

    // SELECT ALL
    app.activeDocument.selection.selectAll();

    // Determine current frame's degree of scaling
    var CurrentStepH = ADegreeH;
    var CurrentStepW = ADegreeW;
    if (differenceH !=0) CurrentStepH = ADegreeH - ((N-1)*(differenceH/(NumberOfLayers-1)));
    if (differenceW !=0) CurrentStepW = ADegreeW - ((N-1)*(differenceW/(NumberOfLayers-1)));

    var ReversePercentH = (100 / CurrentStepH) * 100;
    var ReversePercentW = (100 / CurrentStepW) * 100;
    
    // RESIZE (depending on algorithm selected)
    if ((CurrentStepH == 100)&&(CurrentStepW == 100)) { }
    else {
      if (dlg.AlgPanel.RCW.value==true) {
        ResizeLayer(ReversePercentW, ReversePercentH);
        ContentAwareResizeLayer(CurrentStepW, CurrentStepH);
      }
      else if (dlg.AlgPanel.CWR.value==true) {
        ContentAwareResizeLayer(CurrentStepW, CurrentStepH);
        ResizeLayer(ReversePercentW, ReversePercentH);
      }
      else if (dlg.AlgPanel.CWCW.value==true) {
        ContentAwareResizeLayer(CurrentStepW, CurrentStepH);
        ContentAwareResizeLayer(ReversePercentW, ReversePercentH);
      }      
    }

    // SELECT NEXT LAYER UP
    app.activeDocument.activeLayer = app.activeDocument.layers[Math.max(0,((NumberOfLayers-1) - N))]
    N++;
  }


    // DELETE EXISTING ANIMATION
    var idDlt = charIDToTypeID( "Dlt " );
        var desc23 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
            var ref20 = new ActionReference();
            var idanimationClass = stringIDToTypeID( "animationClass" );
            var idOrdn = charIDToTypeID( "Ordn" );
            var idTrgt = charIDToTypeID( "Trgt" );
            ref20.putEnumerated( idanimationClass, idOrdn, idTrgt );
        desc23.putReference( idnull, ref20 );
    executeAction( idDlt, desc23, DialogModes.NO );

    // MAKE FRAMES FROM LAYERS
    var idanimationFramesFromLayers = stringIDToTypeID( "animationFramesFromLayers" );
        var desc22 = new ActionDescriptor();
    executeAction( idanimationFramesFromLayers, desc22, DialogModes.NO );


win.close();
}

// http://neilcicierega.tumblr.com